local Lib = MissionMinderPreLoad;
local DEBUG = MissionMinderPreLoad.debug;


MissionMinderPreLoadGlobals = {};
local MissionMinderPreLoadGlobals_DEFAULT = {
	["Characters"] = {},
};

local autocreate = {
	__index = function(self, key) -- Create empty table for previously unknown entries
		rawset(self, key, {})
		return key
	end
}


local function initialize()
	DEBUG("   |cffffffffpreload-Options|r initialized");

	-- Set Globals.Characters to automatically create new entries
	MissionMinderPreLoadGlobals.Characters = setmetatable(MissionMinderPreLoadGlobals.Characters, autocreate)

	-- SavedVariables have been loaded, rewrite to include any new or missing values
	for key,value in pairs(MissionMinderPreLoadGlobals_DEFAULT) do
		if MissionMinderPreLoadGlobals[key] == nil then
			MissionMinderPreLoadGlobals[key] = value;
		end
	end

	-- Rewrite to remove any deprecated settings
	for key,value in pairs(MissionMinderPreLoadGlobals) do
		if MissionMinderPreLoadGlobals_DEFAULT[key] == nil then
			MissionMinderPreLoadGlobals[key] = nil;
		end
	end

	Lib.Globals = MissionMinderPreLoadGlobals;
end

Lib:RegisterEvent("options", "ADDON_LOADED", initialize);
